<?

function initVar( $var, $default ) {
  global $$var;
  global $HTTP_GET_VARS;
  $$var = $default;
  if( isset( $HTTP_GET_VARS[$var] ) )
    $$var = $HTTP_GET_VARS[$var];
  return $$var;
}

function initPVar( $var, $default ) {
  global $$var;
  global $HTTP_POST_VARS;
  $$var = $default;
  if( isset( $HTTP_POST_VARS[$var] ) )
    $$var = $HTTP_POST_VARS[$var];
  return $$var;
}

function getSmarty( ) {
  global $smarty;
  $smarty = new Smarty;
  $smarty->template_dir = "../smarty/templates/";
  $smarty->compile_dir = "../smarty/templates_c/";
  $smarty->plugins_dir[] = '../smarty/plugins';
}

function getAdminSmarty( ) {
  global $smarty;
  $smarty = new Smarty;
  $smarty->template_dir = "../../smarty/templates/";
  $smarty->compile_dir = "../../smarty/templates_c/";
  $smarty->plugins_dir[] = '../smarty/plugins';
}

function getIntText( $name ) {
  global $itext;
  return $itext[ $name ];
}

function getSetting( $name ) {
  global $db;
  $db->query( "SELECT `value` FROM `settings` WHERE `name` = '" . $name . "';" );
  $db->next_record( );
  return $db->f( "value" );
}

function setSetting( $name, $value ) {
  global $db;
  $db->query( "REPLACE INTO `settings` (`name`, `value`) ".
              "VALUES ('" . $name . "', '" . $value . "') " );
}

function makeCleanString( $str ) {
  $str = ereg_replace( '[^0-9a-zA-Z.\ +_@/-]', '', $str );
  $str = ereg_replace( '\.{1,}', '.', $str );
  return $str;
}

function makeCleanPath( $str ) {
  $str = ereg_replace( "[/]+", "/", makeCleanString( $str ) . "/" );
  if( substr( $str, 0, 1 ) == "/" && strlen( $str ) > 1 ) {
    return substr( $str, 1 );
  } else {
    return $str;
  }
}

function replaceWhitespace( $str ) {
  return ereg_replace( ' ', '%20', $str );
}
// DrScream - ReGen Unixtimestamp
function parsedate($value)
{
   $reformatted = preg_replace("/^\s*([0-9]{1,2})[\/\. -]+([0-9]{1,2})[\/\. -]+([0-9]{1,4})/", "\\2/\\1/\\3", $value);
   return strtotime($reformatted);
}
// DrScream - FolderListing - like `ls`
class FolderListing {
   var $newarr = array();

   function loop($stack) {
       if(count($stack) > 0) {
           $arr = array();
           foreach($stack as $key => $value) {
               array_push($this->newarr, $stack[$key]);
               if ($dir = @opendir($stack[$key])) {
                   while (($file = readdir($dir)) !== false) {
                       if (($file != '.') && ($file != '..')) {
                           array_push($arr, $stack[$key].'/'.$file);
                       }
                   }
               }
           }
           $this->loop($arr);
       } else {
           $sorted = sort($this->newarr);
           return($sorted);
       }
   }
}

// DrScream - Reverse strrchr
function reverse_strrchr( $haystack, $needle ) {
   $pos = strrpos( $haystack, $needle );
   if( $pos === false ) {
       return $haystack;
   }
   return substr( $haystack, 0, $pos );
}

// DrScream - is url
function is_url($url) {
  if( preg_match( '/^(http|https):\/\/[a-z0-9]+([\-\.]{1}[a-z0-9]+)*\.[a-z]{2,5}'
                 .'((:[0-9]{1,5})?\/.*)?$/i' ,$url)) 
	return true;
   else 
	return false;
}
function is_mail($mail) {
 if (ereg("^[0-9a-z]([-_.]?[0-9a-z])*@[0-9a-z]([-.]?[0-9a-z])*\\.[a-z]{2,4}$",$mail))
   return true;
 else
   return false;
} 
?>