<?php
/* mod_blog version 0.4
   by Thomas "DrScream" Merkel */

/* Admin Menu Thingi */
function menu_urls_blog( ) {
  return array(
   "?site=mod_blog_list"
  );
}

function menu_names_blog( ) {
  return array(
   "Blog"
  );
}

function mod_blog_cleanUrl( $id, $title ) {
  return $id . "-" . str_replace( " ", "+", makeCleanString( $title ));
}


function mod_blog_helper_flush( $lang, $date, $title, $url ) {
  if( count( $date ) > 0 ) {
    $smarty_list = new mySmarty;
    $smarty_list->assign( "lang", $lang );
    $smarty_list->assign( "date", $date );
    $smarty_list->assign( "title", $title );
    $smarty_list->assign( "url", $url );
    return $smarty_list->fetch( "mod_blog_archiv_list.tpl" );
  }
  return "";
}

function mod_blog( $p ) {
  $db = new DB_mysql;
  $tt = new Textile;
  $blog = new mySmarty;

  $blog_id = reverse_strrchr( $p[2], '-' );

  /* add comment */
  $blog_f_c_name = htmlentities( initPVar( "blog_f_c_name", "" ), ENT_QUOTES );
  $blog_f_c_mail = htmlentities( initPVar( "blog_f_c_mail", "" ), ENT_QUOTES );
  $blog_f_c_url = htmlentities( initPVar( "blog_f_c_url", "" ), ENT_QUOTES );
  $blog_f_c_comment = htmlentities( initPVar( "blog_f_c_content", "" ), ENT_QUOTES );
  $db->query( "SELECT `ip` FROM `blog_comment` WHERE id_blog = '" . $blog_id . "' ORDER BY `id`  DESC limit 1;" );
  $db->next_record();
  $blog_c_ip = $db->f("ip");

  if( $blog_f_c_name != "" && $blog_f_c_comment != "" && $blog_c_ip != $_SERVER['REMOTE_ADDR'] ) {
    $db->query( "INSERT INTO `blog_comment` (`name`, `date`, `mail`, `url`, `comment`, `ip`, `id_blog`)" .
                "VALUES ('" . $blog_f_c_name . "', '" . date("Y-m-d G:i:s") . "', '" . $blog_f_c_mail . "', " .
                "'" . $blog_f_c_url . "', '" . $blog_f_c_comment . "', '" . $_SERVER['REMOTE_ADDR'] . "', ".
                "'" . $blog_id . "' );" );
    $comment_info = getIntText("blog_insert");
  } elseif( $blog_c_ip == $_SERVER['REMOTE_ADDR'] ) {
    $comment_info = getIntText("ip_limit");
  }

  if( $p[2] == "" ) { /* last 10 */
    $db->query( "SELECT `id`, `date`, `title`, `content` FROM `blog` " .
                "WHERE `language` = '" . $p[0] . "' " .
                "ORDER BY date DESC LIMIT 10;" );
    while( $db->next_record() ) {
      $blog_date[] = $db->f( "date" );
      $blog_title[] = $db->f( "title" );
      $blog_content[] = $tt->TextileThis( substr($db->f( "content" ), 0, 212) );
      $blog_clear_url[] = mod_blog_cleanUrl( $db->f( "id" ), $db->f( "title" ));
    }
    $blog_read = getIntText("blog_read");
    $blog->assign( "lang", $p[0] );
    $blog->assign( "blog_date", $blog_date );
    $blog->assign( "blog_title", $blog_title );
    $blog->assign( "blog_content", $blog_content );
    $blog->assign( "blog_clear_url", $blog_clear_url );
    $blog->assign( "blog_read", $blog_read );
    return $blog->fetch( "mod_blog_last10.tpl" );
  } else { /* exact one */
    $db->query( "SELECT `id`, `date`, `title`, `content` " .
                 "FROM `blog` WHERE `id` = '" . $blog_id . "' LIMIT 1;" );
    if( $db->next_record() ) {
      $blog->assign( "lang", $p[0] );
      $blog->assign( "title", $db->f( "title" ));
      $blog->assign( "date", $db->f( "date" ));
      $blog->assign( "content", $tt->TextileThis( $db->f( "content" )));
      $blog->assign( "blog_url", mod_blog_cleanUrl( $db->f( "id" ), $db->f( "title" )));
      $db->query( "SELECT `id`, `date`, `name`, `mail`, `url`, `comment` " .
                  "FROM `blog_comment` WHERE `id_blog` = '" . $blog_id . "' " .
                  "ORDER BY `date` ASC;" );
      while( $db->next_record() ) {
        $comment_id[] = $db->f( "id" );
        $comment_date[] = $db->f( "date" );
        $comment_name[] = $db->f( "name" );
        if( $db->f( "mail" ) != "mail@example.net" && is_mail( $db->f( "mail" ))) {
          $comment_mail[] = $db->f( "mail" );
        } else {
          $comment_mail[] = "";
        }
        if( $db->f( "url" ) != "http://example.net" && is_url( $db->f( "url" ))) {
          $comment_url[] = $db->f( "url" );
        } else {
          $comment_url[] = "";
        }
        $comment_content[] = $db->f( "comment" );
      }
      $blog->assign( "comment_info", $comment_info );
      $blog->assign( "comment_id", $comment_id );
      $blog->assign( "comment_date", $comment_date );
      $blog->assign( "comment_name", $comment_name );
      $blog->assign( "comment_mail", $comment_mail );
      $blog->assign( "comment_url", $comment_url );
      $blog->assign( "comment_content", $comment_content );
      $blog->assign( "submit", getIntText( "submit" ));
      $blog->assign( "reset", getIntText( "reset" ));
      return $blog->fetch( "mod_blog.tpl" );
    } else { /* archiv */
      $db->query( "SELECT `id`, `date`, `title` FROM `blog` " .
                  "WHERE `language` = '" . $p[0] . "' " .
                  "ORDER BY date DESC;" );
      $old_year = $old_month = "";
      $smarty_jear = new mySmarty;
      $smarty_month = new mySmarty;
      $smarty_list = new mySmarty;
      $content = "";
      while( $db->next_record() ) {
        $tmp_date = $db->f( "date" );
        if( substr( $tmp_date, 0, 4 ) != $old_year ) {
          $content .= mod_blog_helper_flush( $p[0], $blog_date, $blog_title, $blog_url);
          $blog_date = array();
          $blog_title = array();
          $blog_url = array();
          $smarty_jear->assign( "year", substr( $tmp_date, 0, 4 ));
          $content .= $smarty_jear->fetch( "mod_blog_archiv_year.tpl" );
        }
        if( substr( $tmp_date, 5, 2) != $old_month ) {
          $content .= mod_blog_helper_flush( $p[0], $blog_date, $blog_title, $blog_url);
          $blog_date = array();
          $blog_title = array();
          $blog_url = array();
          $smarty_month->assign( "month", getIntText( "month" . substr( $tmp_date, 5, 2 )));
          $content .= $smarty_month->fetch( "mod_blog_archiv_month.tpl" );
        }
        $blog_date[] = $db->f( "date" );
        $blog_title[] = $db->f( "title" );
        $blog_url[] = mod_blog_cleanUrl( $db->f( "id" ), $db->f( "title" ));
        $old_year = substr( $tmp_date, 0, 4 );
        $old_month = substr( $tmp_date, 5, 2 );
      }
      $content .= mod_blog_helper_flush( $p[0], $blog_date, $blog_title, $blog_url);
      $blog->assign( "content", $content );
      return $blog->fetch( "mod_blog_archiv.tpl" );
    }
  }
}

/* Pre Functions */
function pre_mod_blog_del( $p ) {
  $db = new DB_mysql;
  $db->query( "DELETE FROM `blog` WHERE `id` = '" . $p[1] . "' AND `language` = '" . $p[0] . "'" );
  $db->query( "DELETE FROM `blog_comment` WHERE `id_blog` = '" . $p[1] . "'" );
  return "mod_blog_list";
}

function pre_mod_blog_cdel( $p ) {
  $db = new DB_mysql;
  $db->query( "DELETE FROM `blog_comment` WHERE `id` = '" . $p[1] . "'" );
  return "mod_blog_list";
}

function pre_mod_blog_save( $p ) {
   $db = new DB_mysql;
   $blog_title = initPVar( "blog_title", "Neuer Blogeintrag" );
   $blog_date = initPVar( "blog_date", "" );
   $blog_date_old = initPVar( "blog_date_old", "" );
   $blog_content = initPVar( "blog_content", "" );
     if( $blog_title != "Neuer Blogeintrag" && $blog_date_old != "" ) {
       $db->query( "UPDATE blog SET `date` = '" . $blog_date . "', `title` = '" . $blog_title . "', "
                 . "`content` = '" . $blog_content . "' WHERE `date` = '" . $blog_date_old . "' AND `language` = '" . $p[0] . "'" );
     } else {
       $db->query( "INSERT INTO `blog` (`language`, `date`, `title`, `content`) ".
                   "VALUES ('" . $p[0] . "', '" . $blog_date . "','" . $blog_title . "', '" . $blog_content . "') " );
     }
   return "mod_blog_list";
}

/* Admin Functions */
function mod_blog_list( $p ) {
  $db = new DB_mysql;
  $db2 = new DB_mysql;
  $content .="<a href=\"?site=mod_blog_edit&amp;p0=Neuer%20Blogeintrag\">Neuer Blogeintrag</a><br />";
  $content .= "<br /><table class=\"bt\">";

  $db->query( "SELECT `id`, `date`, `title` FROM `blog` WHERE `language` = '" . $p[0] . "' ORDER BY `date` DESC" );
  while ($db->next_record()) {
    $content .= "<tr><td colspan=\"2\">&bull; <a href=\"?site=mod_blog_edit&amp;p0=" 
                . replaceWhitespace( $db->f( "date" )) . "\">[" . $db->f( "date" ) .
                "] " . $db->f( "title" ) . "</a></td><td>( <a href=\"?site=pre_mod_blog_del&amp;p0=" . $db->f( "id" )
                .  "\" onclick=\"return sendFormular();\">Lschen</a> )</td></tr>";
    $db2->query( "SELECT `id`, `date`, `name`, `comment` FROM `blog_comment` WHERE `id_blog` = '" . $db->f( "id" ) . "' ORDER BY `date` ASC" );
    while ($db2->next_record()) {
       $content .= "<tr><td></td><td>&bull; [" . $db2->f( "date" ) . "] " . $db2->f( "name" ) 
                   . "</td><td>( <a href=\"?site=pre_mod_blog_cdel&amp;p0=" . $db2->f( "id" ) . "\" onclick=\"return sendFormular();\">Lschen</a> )</td></tr>";
    }
  }
  $content.="</table>";
  return $content;
}

function mod_blog_edit( $p ) {
  $db = new DB_mysql;
  $db->query( "SELECT `title`, `content` FROM `blog` WHERE `language` = '" . $p[0] . "' AND `date` = '". $p[1] . "'" );
  $blog_date = date("Y-m-d G:i:s");
  $blog_title = "Neuer Blogeintrag";
  $blog_content = "";
  if( $db->next_record()) {
    $blog_date_old = $p[1];
    $blog_date = $p[1];
    $blog_title = $db->f( "title" );
    $blog_content = $db->f( "content" );
  }
  $content .= "<form action=\"?site=pre_mod_blog_save\" method=\"post\">
             <table class=\"bt\"><tr><td>Date: </td><td><input type=\"text\" name=\"blog_date\" value=\""
             . $blog_date . "\" /></td></tr><tr><td>Title: </td><td><input type=\"text\" name=\"blog_title\" value=\""
             . $blog_title . "\" /></td></tr><tr><td>Content: </td><td><textarea type=\"text\" name=\"blog_content\" rows=\"15\" cols=\"60\">"
             . $blog_content. "</textarea>
             </td></tr><tr><td colspan=\"2\"><input type=\"hidden\" name=\"blog_date_old\" value=\"" 
             . $blog_date_old . "\"><input type=\"submit\" value=\"Speichern\" /> <input type=\"reset\" value=\"Original\" /></td></tr></table></form>";
  return $content;
}

?>
