<?php
/* mod_gallery version 0.1 
   by Thomas "DrScream" Merkel 
   and Sebastian "Wiedi" Wiedenroth */

/* Admin Menu Thingi */
function menu_urls_gallery( ) {
  return array(
   "?site=mod_gallery_list",
  );
}

function menu_names_gallery( ) {
  return array(
   "Gallery",
  );
}

/* Main Function */
function mod_gallery( $p ) {
  $db = new DB_mysql;
  $path = $p;
  $img = $p[ count( $p ) - 1 ];
  array_shift( $path ); array_shift( $path ); /* dirty but worky */
  $path = implode( "/", $path );
  $updir = dirname( $path ) . "/";
  if( $updir == "." ) $updir = "";
  if( is_file( "../userdata/img/gallery/" . $path )) {
    if( !is_dir( "../userdata/img/gallery/" . $updir . "/" ))
      return getIntText( "folder_not_found" );
    $imgdir = dir( "../userdata/img/gallery/" . $updir . "/" );
    while( $file = $imgdir->read( )) {
      if( $file == $img ) {
        while( $file = $imgdir->read( )) {
          if( $file == "." || $file == ".."
              || substr( $file, 0, 6 ) == "thumb-" 
              || is_dir( "../userdata/img/gallery/" . $updir . $file )) continue;
          $next = "/" . $p[0] . "/gallery/" . $updir . $file;
          break;
        }
        break;
      }
    }
    if( !isset( $next ))
      $next = "/" . $p[0] . "/gallery/" . $updir;
    $updir = ereg_replace( "[/]+", "/", $updir . "/" );
    $file = "../userdata/img/gallery/" . $updir . "/" . $img;
    $file = ereg_replace( "[/]+", "/", $file );
    $db->query( "UPDATE `count` SET `count`=`count`+1 WHERE `filename` = '" . $file . "'" );
    if( $db->affected_rows() == 0 )
      $db->query( "INSERT INTO `count` (`filename`, `count`) VALUES ( '" . $file . "', 1 )" );
    $gallery = new mySmarty;
    $gallery->assign( "lang", $p[0] );
    $gallery->assign( "fullsize", getIntText( "fullsize" ));
    $gallery->assign( "updir", $updir );
    $gallery->assign( "img", $img );
    $gallery->assign( "next", $next );
    return $gallery->fetch( "mod_gallery_big.tpl" );
  }
  if( !is_dir( "../userdata/img/gallery/" . $path . "/" ))
    return getIntText( "folder_not_found" );
  /* here we give a listing */
  $imgdir = @dir( "../userdata/img/gallery/" . $path . "/" );
  while( $file = $imgdir->read( )) {
    if( $file == "." || $file == ".." || substr( $file, 0, 6 ) == "thumb-" ) continue;
    if( is_dir( "../userdata/img/gallery/" . $path . "/" . $file )) {
      $dirs[] = $file;

    } else {
      if( is_file( "../userdata/img/gallery/" . $path . "/thumb-" . $file ))
        $files[] = $file;

    }
  }
  /* sort the array */
  if(is_array( $dirs )) sort($dirs);
  if(is_array( $files )) sort($files);
  /* this is just makeup */
  $path = ereg_replace( "[/]+", "/", $path . "/" );
  if( $path == "/" ) $path = "";

  $gallery = new mySmarty;
  $gallery->assign( "lang", $p[0] );
  $gallery->assign( "path", $path );
  $gallery->assign( "updir", $updir );
  $gallery->assign( "dirs", $dirs );
  $gallery->assign( "files", $files );
  return $gallery->fetch( "mod_gallery_browse.tpl" );
}

function pre_mod_gallery_activate( $p ) {
  $cmd = "convert -scale 88 \"../../userdata/img/gallery/" . $p[1]. $p[2] . "\" \"../../userdata/img/gallery/" . $p[1] . "thumb-" . $p[2] . "\"";
  $cmd = ereg_replace( "[/]+", "/", $cmd );
  system( $cmd );
  return "mod_gallery_list";
}

function pre_mod_gallery_activateall( $p ) {
  $path = makeCleanString( initVar( "path", "" ));
  $imgdir = dir( "../../userdata/img/gallery/" . $path . "/" );
  $updir = $path . "/";
  while( $file = $imgdir->read( )) {
    if( $file == "." || $file == ".."
        || substr( $file, 0, 6 ) == "thumb-"
        || is_dir( "../../userdata/img/gallery/" . $updir . $file )) continue;
    if( !is_file( "../../userdata/img/gallery/" . $updir . "thumb-" . $file )) {
      $cmd = "convert -scale 88 \"../../userdata/img/gallery/" . $updir . $file . "\" \"../../userdata/img/gallery/" . $updir . "thumb-" . $file . "\"";
      $cmd = ereg_replace( "[/]+", "/", $cmd );
      system( $cmd );
    }
  }
  return "mod_gallery_list";
}

function pre_mod_gallery_deactivate( $p ) {
  @unlink( "../../userdata/img/gallery/" . $p[1] );
  return "mod_gallery_list";
}

function mod_gallery_list( $p ) {
  $db = new DB_mysql;
  $path = makeCleanString( initVar( "path", "" ));
  $imgdir = dir( "../../userdata/img/gallery/" . $path . "/" );
  $content .= "<ul><li><a href=\"?site=pre_mod_gallery_activateall&amp;path=" . $path . "\">Alle Aktivieren</a></li></ul>";
  $content .= "<br /><table class=\"bt\">";

  $updir = dirname( $path );
  while($file = $imgdir->read()) {
    if( $file == "." || $file == ".." || substr( $file, 0, 6 ) == "thumb-" ) continue;
    if( is_dir("../../userdata/img/gallery/" . $path . "/" . $file )) {
      $dirs[] = $file;
    } else {
      $files[] = $file;
      $act[] = ( is_file( "../../userdata/img/gallery/" . $path . "/thumb-"  . $file )) ? 1 : 0 ;
    }
  }
  /* sort the array */
  if(is_array( $dirs )) sort($dirs);
  if(is_array( $files )) sort($files);
  if( $path == "" ) {
    $path = "/";
  } else {
  $content .= "<tr><td><img src=\"/theme/img/dir-small.png\" /></td><td><a href=\"?site=mod_gallery_list&amp;path=" . $updir .  "\"> ( Aufwrts ) </a></td>"
           . "<td>&nbsp;</td><td>&nbsp;</td></tr>";
  }
  if( isset( $dirs )) {
    foreach( $dirs as $dir ) {
      $content .= "<tr><td><img src=\"/theme/img/dir-small.png\" /></td><td><a href=\"?site=mod_gallery_list&amp;path=" . $path . "/" .  $dir .  "\">" . $dir . "</a></td>"
               . "<td>&nbsp;</td><td>&nbsp;</td></tr>";
    }
  }
  $path = ereg_replace( "[/]+", "/", $path );
  if( isset( $files )) {
    $c = 0;
    foreach( $files as $file ) {
      $db->query( "SELECT `count` FROM `count` WHERE `filename` = '../userdata/img/gallery" . $path . "/" . $file . "'" );
      if( $db->next_record() ) {
        $count = $db->f( "count" );
      } else {
        $count = 0;
      }
      $content .= "<tr><td><img src=\"/theme/img/img-small.png\" /></td><td><a target=\"_blank\" href=\"../../userdata/img/gallery" . $path . "/" . $file . "\">" . $file . "</a></td>";
      $content .= "<td>(Downloads: " .  $count . ")</td>";
      if( $act[ $c ] )
        $content .= "<td>( <a href=\"?site=pre_mod_gallery_deactivate&amp;p0=" . $path . "/thumb-" . $file .  "&amp;path=" . $path . "\">Dektivieren</a> )</td><td>&nbsp;</td></tr>";
      else
        $content .= "<td>&nbsp;</td><td>( <a href=\"?site=pre_mod_gallery_activate&amp;p0=" . $path . "/&amp;p1=" . $file .  "&amp;path=" . $path . "\">Aktivieren</a> )</td></tr>";
      $c++;
    }
  }
  $content.="</table>";
  $imgdir->close();
  return $content;
}

?>
