<?php
/* mod_gb version 0.1
   by Thomas "DrScream" Merkel */

/* Admin Menu Thingi */
function menu_urls_gb( ) {
  return array(
   "?site=mod_gb_list"
  );
}

function menu_names_gb( ) {
  return array(
   "Gstebuch"
  );
}

function mod_gb( $p ) {
  require('classCaptcha.php');
  $db = new DB_mysql;
  $gb_name = htmlentities( initPVar( "gb_name", "" ), ENT_QUOTES );
  $gb_mail = initPVar( "gb_mail", "" );
  $gb_url = initPVar( "gb_url", "" );
  $gb_comment = htmlentities( initPVar( "gb_comment", "" ), ENT_QUOTES );

  $db->query( "SELECT `ip` FROM `gb` " .
              "ORDER BY `id` DESC limit 1;" );
  $db->next_record(); $gb_ip = $db->f("ip");

  if( $gb_name != "" && $gb_comment != ""
   && $gb_ip != $_SERVER['REMOTE_ADDR']
   && PhpCaptcha::Validate(strtolower($_POST['gb_captcha']))) {
     $db->query( "INSERT INTO `gb` (`name`, `when`, `mail`, `url`, `comment`, `ip`)" .
                 "VALUES ('" . $gb_name . "', '" . date("Y-m-d H:i:s") . "', '" . $gb_mail . "', '" . $gb_url . "', '" . $gb_comment . "', '" . $_SERVER['REMOTE_ADDR'] . "');" );
     $gb_info = getIntText("gb_insert");
  }
  elseif( $gb_ip == $_SERVER['REMOTE_ADDR'] ) {
     $gb_info = getIntText("ip_limit");
  } else {
     $gb_info = getIntText("comment_error");
  }

  $page = $p[2];

  if($p[2] == "" )
    $page = 1;

  $db->query( "SELECT `id`, `name`, `when`, `mail`, `url`, `comment` FROM `gb` " .
              "ORDER BY `when` DESC LIMIT " . intval($page - 1) * 14 . ", " . 14 . ";" );
  while( $db->next_record( )) {
    $name[] = $db->f( "name" );
    $when[] = $db->f( "when" );
    $mail[] = $db->f( "mail" );
    $chk_mail[] = is_mail($db->f( "mail" ));
    $url[] = $db->f( "url" );
    $chk_url[] = is_url($db->f( "url" ));
    $comment[] = $db->f( "comment" );
  }

  $db->query("SELECT count(id) AS `count` FROM `gb`");
  $db->next_record(); $count = $db->f("count");

  $pages = ceil($count / 14);
  define('PADDING', 9);

  // erste seite
  if( $page - PADDING > 1 )
	$gb_page .= '[<a class="hefo" href="/'.$p[0].'/'.$p[1].'/">first</a>] ... ';
  $i = $page - PADDING;
  if( $i < 1 )
	$i = 1;
  $imax = $page + PADDING;
  if( $imax > $pages )
	$imax = $pages; 	
  for( $i; $i <= $imax; $i++ ) {
     if( $i == $page )
	$gb_page .=  ' &gt;'.$i.'&lt; ';
     else
	$gb_page .= '[<a href="/'.$p[0].'/'.$p[1].'/'.$i.'/">'.$i.'</a>] ';
  }

  // letzte seite
  if( $page + PADDING < $pages )
	$gb_page .= '... [<a href="/'.$p[0].'/'.$p[1].'/'.$pages.'/">last</a>]';

  $submit = getIntText("submit");
  $reset = getIntText("reset");
  $gb = new mySmarty;
  $gb->assign( "submit", $submit );
  $gb->assign( "reset", $reset );
  $gb->assign( "gb_info", $gb_info );
  $gb->assign( "lang", $p[0] );
  $gb->assign( "name", $name );
  $gb->assign( "when", $when );
  $gb->assign( "mail", $mail );
  $gb->assign( "chk_mail", $chk_mail );
  $gb->assign( "url", $url );
  $gb->assign( "chk_url", $chk_url );
  $gb->assign( "comment", $comment );
  $gb->assign( "page", $gb_page );

  $content = $gb->fetch( "mod_gb.tpl" );
  return $content;
}

/* Admin Pre-Function test */
function pre_mod_gb_del( $p ) {
  $db = new DB_mysql;
  $db->query( "DELETE FROM `gb` WHERE `when` = '" . $p[1] . "'" );
  return "mod_gb_list";
}

function mod_gb_list( $p ) {
  $db = new DB_mysql;

  $content .= "<br /><table class=\"bt\">";
  $db->query( "SELECT `when`, `name`, `comment`, `ip` FROM `gb` ORDER BY `when` DESC" );
  while ($db->next_record()) {
    $content .= "<tr><td class=\"newstitle\">" . $db->f("name")
              . "</td><td class=\"newsdate\">" . $db->f("when") . "</td></tr>"
              . "<tr><td>" . $db->f("comment") . "</td></tr>"
              . "<tr><td>" . $db->f( "ip" ) . "</td><td>( <a href=\"?site=pre_mod_gb_del&amp;p0=" . $db->f( "when" ) .  "\" onclick=\"return sendFormular();\"> Lschen </a> )</td></tr>";
  }
  $content.="</table>";
  return $content;

}

?>
